// Perfect p-th powers ; UVa 10622

#include <iostream>
#include <math.h>

#define EPSILON 10e-8

// pour vrifier aprs le calcul avec les exp et log qu'il n'y a
// pas eu de problme d'arrondi
int puissance(int n, int i)
{
  int aux;
  if (i == 1)
    return n;
  aux = puissance(n, i/2);
  if (i % 2 == 0)
    return aux*aux;
  return aux*aux*n;
}

int main()
{
  double n, racine, racine_entiere;
  int i;

  std::cin >> n;

  while (fabs(n) > 0.5)
    {
      i = 32 ;
      while (i > 1)
	{
	  // calcul de la racine i-me
	  racine = exp(log(fabs(n))/i);
	  // partie entire infrieure, modulo arrondis
	  racine_entiere = floor(racine+EPSILON);

	  if ((racine - racine_entiere < EPSILON)
	      && ((n > 0)||(i%2==1))
	      && (((int) fabs(n)) == puissance((int) racine_entiere, i)))
	    break;
	  --i;
	}
      std::cout << i << std::endl;
      std::cin >> n;
    }
}
